Index: Fl_x.cxx
===================================================================
--- Fl_x.cxx	(revision 7831)
+++ Fl_x.cxx	(working copy)
@@ -1164,6 +1164,17 @@
       // MRS: Can't use Fl::event_state(FL_CTRL) since the state is not
       //      set until set_event_xy() is called later...
       if ((xevent.xkey.state & ControlMask) && keysym == '-') buffer[0] = 0x1f; // ^_
+#ifdef __sgi
+      // STR #2444: The following makes ^c/^v/^a shortcuts work on SGI to remote linux X server. -erco
+      if ((xevent.xkey.state & ControlMask) &&			// ctrl key?
+          (xevent.xkey.state & ~(ControlMask|LockMask)) &&	// no other modifiers (ignore capslock)
+	  (
+	    (keysym >= 'a' && keysym <= 'z') ||			// letter key?
+	    (keysym >= 'A' && keysym <= 'Z')
+	  ) {
+	buffer[0] &= 0x1f;
+      }
+#endif /*__sgi**/
       buffer[len] = 0;
       Fl::e_text = buffer;
       Fl::e_length = len;
